"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.QueryClientProvider = exports.useQueryClient = void 0;

var _react = _interopRequireDefault(require("react"));

var QueryClientContext = /*#__PURE__*/_react.default.createContext(undefined);

var useQueryClient = function useQueryClient() {
  return _react.default.useContext(QueryClientContext);
};

exports.useQueryClient = useQueryClient;

var QueryClientProvider = function QueryClientProvider(_ref) {
  var client = _ref.client,
      children = _ref.children;

  _react.default.useEffect(function () {
    client.mount();
    return function () {
      client.unmount();
    };
  }, [client]);

  return /*#__PURE__*/_react.default.createElement(QueryClientContext.Provider, {
    value: client
  }, children);
};

exports.QueryClientProvider = QueryClientProvider;