import { MutationOptions } from './types';
import { QueryClient } from './queryClient';
import { Mutation, MutationState } from './mutation';
import { Subscribable } from './subscribable';
declare type MutationCacheListener = (mutation?: Mutation) => void;
export declare class MutationCache extends Subscribable<MutationCacheListener> {
    private mutations;
    private mutationId;
    constructor();
    build<TData, TError, TVariables, TContext>(client: QueryClient, options: MutationOptions<TData, TError, TVariables, TContext>, state?: MutationState<TData, TError, TVariables, TContext>): Mutation<TData, TError, TVariables, TContext>;
    add(mutation: Mutation<any, any, any, any>): void;
    remove(mutation: Mutation<any, any, any, any>): void;
    clear(): void;
    getAll(): Mutation[];
    notify(mutation?: Mutation<any, any, any, any>): void;
    onFocus(): void;
    onOnline(): void;
    resumePausedMutations(): Promise<void>;
}
export {};
