import { QueryFilters } from './utils';
import { Query, QueryState } from './query';
import { QueryKey, QueryOptions } from './types';
import { QueryClient } from './queryClient';
import { Subscribable } from './subscribable';
declare type QueryCacheListener = (query?: Query) => void;
export declare class QueryCache extends Subscribable<QueryCacheListener> {
    private queries;
    private queriesMap;
    constructor();
    build<TData, TError, TQueryFnData>(client: QueryClient, options: QueryOptions<TData, TError, TQueryFnData>, state?: QueryState<TData, TError>): Query<TData, TError, TQueryFnData>;
    add(query: Query<any, any>): void;
    remove(query: Query<any, any>): void;
    clear(): void;
    get<TData = unknown, TError = unknown, TQueryFnData = TData>(queryHash: string): Query<TData, TError, TQueryFnData> | undefined;
    getAll(): Query[];
    find<TData = unknown, TError = unknown, TQueryFnData = TData>(arg1: QueryKey, arg2?: QueryFilters): Query<TData, TError, TQueryFnData> | undefined;
    findAll(queryKey?: QueryKey, filters?: QueryFilters): Query[];
    findAll(filters?: QueryFilters): Query[];
    findAll(arg1?: QueryKey | QueryFilters, arg2?: QueryFilters): Query[];
    notify(query?: Query<any, any>): void;
    onFocus(): void;
    onOnline(): void;
}
export {};
